#line 1 "X:/Mikromedia Board/Stereo3D Viewer/Mikromedia Stereo3D Viewer/Development/PIC32/Stereo3D_Code/mikroC PRO for PIC32/Stereo3D_driver.c"
#line 1 "x:/mikromedia board/stereo3d viewer/mikromedia stereo3d viewer/development/pic32/stereo3d_code/mikroc pro for pic32/stereo3d_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int ImagesCount;
 TImage * const code *Images;
};

extern TScreen left;
extern TImage leftImage;
extern TImage * const code Screen1_Images[1];


extern TScreen right;
extern TImage rightImage;
extern TImage * const code Screen2_Images[1];





void leftImageOnUp();
void rightImageOnUp();




extern char leftImage_Caption[];
extern char rightImage_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawImage(TImage *AImage);
void Check_TP();
void Start_TP();
#line 1 "x:/mikromedia board/stereo3d viewer/mikromedia stereo3d viewer/development/pic32/stereo3d_code/mikroc pro for pic32/stereo3d_resources.h"
#line 1 "c:/program files/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 7 "X:/Mikromedia Board/Stereo3D Viewer/Mikromedia Stereo3D Viewer/Development/PIC32/Stereo3D_Code/mikroC PRO for PIC32/Stereo3D_driver.c"
sbit Mmc_Chip_Select at LATG9_bit;
sbit Mmc_Chip_Select_Direction at TRISG9_bit;


unsigned long currentSector = -1, res_file_size;





char TFT_DataPort at LATE;
sbit TFT_RST at LATC1_bit;
sbit TFT_BLED at LATA9_bit;
sbit TFT_RS at LATB15_bit;
sbit TFT_CS at LATF12_bit;
sbit TFT_RD at LATD5_bit;
sbit TFT_WR at LATD4_bit;
char TFT_DataPort_Direction at TRISE;
sbit TFT_RST_Direction at TRISC1_bit;
sbit TFT_BLED_Direction at TRISA9_bit;
sbit TFT_RS_Direction at TRISB15_bit;
sbit TFT_CS_Direction at TRISF12_bit;
sbit TFT_RD_Direction at TRISD5_bit;
sbit TFT_WR_Direction at TRISD4_bit;



sbit DRIVEX_LEFT at LATB13_bit;
sbit DRIVEX_RIGHT at LATB11_bit;
sbit DRIVEY_UP at LATB12_bit;
sbit DRIVEY_DOWN at LATB10_bit;
sbit DRIVEX_LEFT_DIRECTION at TRISB13_bit;
sbit DRIVEX_RIGHT_DIRECTION at TRISB11_bit;
sbit DRIVEY_UP_DIRECTION at TRISB12_bit;
sbit DRIVEY_DOWN_DIRECTION at TRISB10_bit;



unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 1000;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TImage *local_image;
TImage *exec_image;
int image_order;

void PMPWaitBusy() {
 while(PMMODEbits.BUSY);
}

void Set_Index(unsigned short index) {
 TFT_RS = 0;
 PMDIN = index;
 PMPWaitBusy();
}

void Write_Command( unsigned short cmd ) {
 TFT_RS = 1;
 PMDIN = cmd;
 PMPWaitBusy();
}

void Write_Data(unsigned int _data) {
 TFT_RS = 1;
 PMDIN = _data;
 PMPWaitBusy();
}


void Init_ADC() {
 AD1PCFG = 0xFFFF;
 PCFG12_bit = 0;
 PCFG13_bit = 0;

 ADC1_Init();
}

char* TFT_Get_Data(unsigned long offset, unsigned long count, unsigned long *num) {
unsigned long start_sector;
unsigned long pos;

 start_sector = Mmc_Get_File_Write_Sector() + offset/512;
 pos = (unsigned long)offset%512;

 if(start_sector == currentSector+1) {
 Mmc_Multi_Read_Sector(f16_sector.fSect);
 currentSector = start_sector;
 } else if (start_sector != currentSector) {
 if(currentSector != -1)
 Mmc_Multi_Read_Stop();
 Mmc_Multi_Read_Start(start_sector);
 Mmc_Multi_Read_Sector(f16_sector.fSect);
 currentSector = start_sector;
 }

 if(count>512-pos)
 *num = 512-pos;
 else
 *num = count;

 return f16_sector.fSect+pos;
}
static void InitializeTouchPanel() {
 Init_ADC();
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init(240, 320);
 TFT_Set_Ext_Buffer(TFT_Get_Data);

 TP_TFT_Init(240, 320, 13, 12);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen left;
 TImage leftImage;
 TImage * const code Screen1_Images[1]=
 {
 &leftImage
 };


 TScreen right;
 TImage rightImage;
 TImage * const code Screen2_Images[1]=
 {
 &rightImage
 };




static void InitializeObjects() {
 left.Color = 0x0000;
 left.Width = 240;
 left.Height = 320;
 left.ImagesCount = 1;
 left.Images = Screen1_Images;
 left.ObjectsCount = 1;

 right.Color = 0x0000;
 right.Width = 240;
 right.Height = 320;
 right.ImagesCount = 1;
 right.Images = Screen2_Images;
 right.ObjectsCount = 1;


 leftImage.OwnerScreen = &left;
 leftImage.Order = 0;
 leftImage.Left = 0;
 leftImage.Top = 0;
 leftImage.Width = 240;
 leftImage.Height = 320;
 leftImage.Picture_Type = 0;
 leftImage.Picture_Ratio = 1;
 leftImage.Picture_Name =  0x0000003B ;
 leftImage.Visible = 1;
 leftImage.Active = 1;
 leftImage.OnUpPtr = leftImageOnUp;
 leftImage.OnDownPtr = 0;
 leftImage.OnClickPtr = 0;
 leftImage.OnPressPtr = 0;

 rightImage.OwnerScreen = &right;
 rightImage.Order = 0;
 rightImage.Left = 0;
 rightImage.Top = 0;
 rightImage.Width = 240;
 rightImage.Height = 320;
 rightImage.Picture_Type = 0;
 rightImage.Picture_Ratio = 1;
 rightImage.Picture_Name =  0x00012E41 ;
 rightImage.Visible = 1;
 rightImage.Active = 1;
 rightImage.OnUpPtr = rightImageOnUp;
 rightImage.OnDownPtr = 0;
 rightImage.OnClickPtr = 0;
 rightImage.OnPressPtr = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}




 void DeleteTrailingSpaces(char* str){
 char i;
 i = 0;
 while(1) {
 if(str[0] == ' ') {
 for(i = 0; i < strlen(str); i++) {
 str[i] = str[i+1];
 }
 }
 else
 break;
 }
 }

void DrawImage(TImage *AImage) {
 if (AImage->Visible) {
 TFT_Ext_Image(AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio);
 }
}

void DrawScreen(TScreen *aScreen) {
 int order;
 unsigned short image_idx;
 TImage *local_image;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 image_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 save_bled_direction = TFT_BLED_Direction;
 TFT_BLED_Direction = 0;
 TFT_BLED = 0;
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
 TFT_Set_Ext_Buffer(TFT_Get_Data);
 TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 13, 12);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);
 TFT_Fill_Screen(CurrentScreen->Color);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 TFT_BLED_Direction = save_bled_direction;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (image_idx < CurrentScreen->ImagesCount) {
 local_image =  CurrentScreen->Images[image_idx] ;
 if (order == local_image->Order) {
 image_idx++;
 order++;
 DrawImage(local_image);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 image_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->ImagesCount ; _object_count++ ) {
 local_image =  CurrentScreen->Images[_object_count] ;
 if (local_image->Active == 1) {
 if (IsInsideObject(X, Y, local_image->Left, local_image->Top,
 local_image->Width, local_image->Height) == 1) {
 image_order = local_image->Order;
 exec_image = local_image;
 }
 }
 }

 _object_count = -1;
 if (image_order > _object_count )
 _object_count = image_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_image = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {
 if (_object_count == image_order) {
 if (exec_image->Active == 1) {
 if (exec_image->OnPressPtr != 0) {
 exec_image->OnPressPtr();
 return;
 }
 }
 }

 }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

 exec_image = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == image_order) {
 if (exec_image->Active == 1) {
 if (exec_image->OnUpPtr != 0)
 exec_image->OnUpPtr();
 if (PressedObject == (void *)exec_image)
 if (exec_image->OnClickPtr != 0)
 exec_image->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_image = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == image_order) {
 if (exec_image->Active == 1) {
 PressedObject = (void *)exec_image;
 PressedObjectType = 3;
 if (exec_image->OnDownPtr != 0) {
 exec_image->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (TP_TFT_Press_Detect()) {

 if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
}

void Init_MCU() {
 PMMODE = 0;
 PMAEN = 0;
 PMCON = 0;
 PMMODEbits.MODE = 2;
 PMMODEbits.WAITB = 0;
 PMMODEbits.WAITM = 1;
 PMMODEbits.WAITE = 0;
 PMMODEbits.MODE16 = 1;
 PMCONbits.CSF = 0;
 PMCONbits.PTRDEN = 1;
 PMCONbits.PTWREN = 1;
 PMCONbits.PMPEN = 1;
 TP_TFT_Rotate_180(0);
 TFT_Set_Active(Set_Index,Write_Command,Write_Data);
}

void Init_Ext_Mem() {

 SPI2_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 64, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);
 Delay_ms(10);


 if (!Mmc_Fat_Init()) {

 SPI2_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 4, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);


 Mmc_Fat_Assign("Stereo3D.RES", 0);
 Mmc_Fat_Reset(&res_file_size);
 }
}

void Start_TP() {
 Init_MCU();

 Init_Ext_Mem();

 InitializeTouchPanel();


 TP_TFT_Set_Calibration_Consts(76, 907, 77, 915);

 InitializeObjects();
 display_width = left.Width;
 display_height = left.Height;
 DrawScreen(&left);
}
