typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Image {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const char    *Picture_Name;
  char          Visible;
  char          Active;
  char          Picture_Type;
  char          Picture_Ratio;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TImage;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned short         ObjectsCount;
  unsigned int           ImagesCount;
  TImage                 * const code *Images;
};

extern   TScreen                left;
extern   TImage               leftImage;
extern   TImage                 * const code Screen1_Images[1];


extern   TScreen                right;
extern   TImage               rightImage;
extern   TImage                 * const code Screen2_Images[1];



/////////////////////////
// Events Code Declarations
void leftImageOnUp();
void rightImageOnUp();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char leftImage_Caption[];
extern char rightImage_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawImage(TImage *AImage);
void Check_TP();
void Start_TP();
